> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.cloudraker.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.cloudraker.com/_mcp/server.

# List template data objects

GET /api/project-templates/{templateId}/data-objects

Lists object definitions scoped to a project template. Requires `project-template:use`.

Reference: https://docs.cloudraker.com/api/raker-one-api/data-objects/get-project-templates-by-template-id-data-objects

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: RakerOne API
  version: 1.0.0
paths:
  /project-templates/{templateId}/data-objects:
    get:
      operationId: get-project-templates-by-template-id-data-objects
      summary: List template data objects
      description: >-
        Lists object definitions scoped to a project template. Requires
        `project-template:use`.
      tags:
        - subpackage_dataObjects
      parameters:
        - name: templateId
          in: path
          required: true
          schema:
            type: string
        - name: archived
          in: query
          description: Include archived definitions when `true`.
          required: false
          schema:
            type: boolean
        - name: Authorization
          in: header
          description: >-
            WorkOS session JWT or an organization API key, sent as
            `Authorization: Bearer <token>`.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The template's object definitions.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DataObjectList'
        '401':
          description: Unauthorized — missing or invalid bearer token.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '403':
          description: Forbidden — the caller lacks the required permission.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
servers:
  - url: /api
    description: Current origin
  - url: https://app.raker.one/api
    description: Production
components:
  schemas:
    DataObjectScope:
      type: string
      enum:
        - library
        - template
        - project
      title: DataObjectScope
    JsonObject:
      type: object
      additionalProperties:
        description: Any type
      description: An arbitrary JSON object.
      title: JsonObject
    DataObjectCardinality:
      type: object
      properties:
        min:
          type: number
          format: double
        max:
          type:
            - number
            - 'null'
          format: double
      required:
        - min
        - max
      title: DataObjectCardinality
    DataObject:
      type: object
      properties:
        _id:
          type: string
        scope:
          $ref: '#/components/schemas/DataObjectScope'
        templateId:
          type:
            - string
            - 'null'
        projectId:
          type:
            - string
            - 'null'
        nameSingular:
          type: string
        namePlural:
          type: string
        labelSingular:
          type: string
        labelPlural:
          type: string
        description:
          type: string
        icon:
          type: string
        color:
          type:
            - string
            - 'null'
        labelFieldKey:
          type: string
        fields:
          type: array
          items:
            $ref: '#/components/schemas/JsonObject'
        fieldGroups:
          type: array
          items:
            $ref: '#/components/schemas/JsonObject'
        cardinality:
          $ref: '#/components/schemas/DataObjectCardinality'
        version:
          type: number
          format: double
        archivedAt:
          type:
            - string
            - 'null'
        createdAt:
          type: string
        updatedAt:
          type: string
        createdBy:
          type: string
      required:
        - _id
        - scope
        - templateId
        - projectId
        - nameSingular
        - namePlural
        - labelSingular
        - labelPlural
        - description
        - icon
        - color
        - labelFieldKey
        - fields
        - fieldGroups
        - version
        - archivedAt
        - createdAt
        - updatedAt
        - createdBy
      title: DataObject
    DataObjectList:
      type: object
      properties:
        definitions:
          type: array
          items:
            $ref: '#/components/schemas/DataObject'
      required:
        - definitions
      title: DataObjectList
    ErrorResponse:
      type: object
      properties:
        error:
          type: string
          description: Machine-readable error code (e.g. `invalid_body`, `not_found`).
        issues:
          type: array
          items:
            description: Any type
          description: Schema-validation issues, present when `error` is `invalid_body`.
      required:
        - error
      description: Standard API error response.
      title: ErrorResponse
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: >-
        WorkOS session JWT or an organization API key, sent as `Authorization:
        Bearer <token>`.

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "definitions": [
    {
      "_id": "60f7a1c2d4e3b45a9f123456",
      "scope": "template",
      "templateId": "tpl_9f8e7d6c5b4a3210",
      "projectId": null,
      "nameSingular": "Task",
      "namePlural": "Tasks",
      "labelSingular": "Task",
      "labelPlural": "Tasks",
      "description": "A unit of work to be completed within the project template.",
      "icon": "check_circle",
      "color": "#4A90E2",
      "labelFieldKey": "title",
      "fields": [
        {
          "key": "title",
          "type": "string",
          "required": true,
          "description": "The title of the task."
        },
        {
          "key": "dueDate",
          "type": "date",
          "required": false,
          "description": "The due date for the task."
        },
        {
          "key": "completed",
          "type": "boolean",
          "required": false,
          "description": "Whether the task has been completed."
        }
      ],
      "fieldGroups": [
        {
          "name": "Basic Info",
          "fields": [
            "title",
            "dueDate"
          ]
        },
        {
          "name": "Status",
          "fields": [
            "completed"
          ]
        }
      ],
      "version": 3,
      "archivedAt": null,
      "createdAt": "2023-11-15T09:30:00Z",
      "updatedAt": "2024-05-20T16:45:00Z",
      "createdBy": "user_1234567890abcdef",
      "cardinality": {
        "min": 1,
        "max": null
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api/project-templates/templateId/data-objects"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api/project-templates/templateId/data-objects';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api/project-templates/templateId/data-objects"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api/project-templates/templateId/data-objects")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api/project-templates/templateId/data-objects")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api/project-templates/templateId/data-objects', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api/project-templates/templateId/data-objects");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api/project-templates/templateId/data-objects")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```